//-----------------------------------------------------------------------
//
// These routines are used to protect non-rentrant functions
//
// Uses a Semaphore
//
//
//-----------------------------------------------------------------------

#include <stdio.h>
#include "task.h"
#include "queue.h"

static Wait *MemoryEvent = (Wait *)0;
static Flag = 0;

extern "C" {
void InitDisable(void)
{
	MemoryEvent = new Wait(1,"MallocBlocker");	//can be used once before pending
	Flag = 1;		//ok to start using Disable and Enable
}

void DISABLE(void)
{
	if(!Flag) return;	//very dangerous
	MemoryEvent->Pend();
}

void ENABLE(void)
{
	if(!Flag) return;	//very dangerous
	MemoryEvent->Post();
}
}
