/*********************************************************************
**
** Header file for Region.s
**
** These function retrieve nessesary information about the relative
** address areas for the Tinybaisc interpreter
**
**********************************************************************/

#ifndef REGION__H
#define REGION__H


extern "C" {
int RelRamSize(void);	//get size of relative ram area size
int RelDataSize(void);	//get size of data ram area size
char *DataAddress(void);	//get address of data stored in rom
}


#endif
